<?php
namespace Magenest\Salesforce\Block\Adminhtml\Connection;

use Magenest\Salesforce\Model\Connector;
use Magenest\Salesforce\Logger\Logger;
use Magento\Backend\Block\Template;
use Magento\Config\Model\ResourceModel\Config;

class Status extends Template
{
    /**
     * Set Template
     *
     * @var string
     */
    protected $_template = 'system/config/connection/status.phtml';

    /** @var Connector  */
    protected $connector;

    /** @var Logger  */
    protected $_logger;

    /**
     * @var Config
     */
    protected $config;

    /**
     * Status constructor.
     * @param Template\Context $context
     * @param Connector $connector
     * @param Logger $logger
     * @param Config $config
     * @param array $data
     */
    public function __construct(
        Template\Context $context,
        Connector $connector,
        Logger $logger,
        Config $config,
        array $data = []
    ) {
        $this->connector = $connector;
        $this->_logger = $logger;
        $this->config = $config;
        parent::__construct($context, $data);
    }

    /**
     * @return int
     */
    public function isConnected()
    {
        $isConnected = $this->_scopeConfig->getValue(Connector::XML_PATH_SALESFORCE_IS_CONNECTED);
        if ($isConnected === null) {
            $this->config->saveConfig(Connector::XML_PATH_SALESFORCE_IS_CONNECTED, '0', 'default', 0);
            $this->_scopeConfig->clean();
            return 0;
        } elseif ($isConnected == '0') {
            return 1;
        } else {
            return 2;
        }
    }
}
