<?php
namespace Magenest\Salesforce\Controller\Adminhtml\Queue;

use Magenest\Salesforce\Model\Queue;
use Magento\Sales\Api\Data\OrderInterface;

/**
 * Class Order
 * @package Magenest\Salesforce\Controller\Adminhtml\Sync
 */
class Order extends \Magenest\Salesforce\Controller\Adminhtml\Queue\AbstractionAction
{

    /** @var string */
    protected $type = Queue::TYPE_ORDER;

    /**
     * @return \Magento\Framework\App\ResponseInterface
     */
    public function execute()
    {
        if ($this->getRequest()->isAjax()) {
            try {
                $orderCollection = $this->_orderColFactory->create()->addFieldToSelect(OrderInterface::INCREMENT_ID);
                $ids = $this->getFilterDate($orderCollection)->getColumnValues(OrderInterface::INCREMENT_ID);
                $queueIds = $this->getQueueIdsByType($this->type);
                $this->_queueResource->deleteMultiQueues($queueIds);
                $this->publishData($ids, $this->type);
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 0,
                    'message' => __('All Orders are being added to queue.')
                ]));
                return;
            } catch (\Exception $e) {
                $this->_logger->critical($e->getMessage());
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 0,
                    'message' => __('Something went wrong while adding record(s) to queue. Error: ' . $e->getMessage())
                ]));
                return;
            }
        }
        return $this->_redirect('*/*/index');
    }
}
