<?php
namespace Magenest\Salesforce\Controller\Adminhtml\Queue;

use Magenest\Salesforce\Model\Queue;

/**
 * Class Product
 * @package Magenest\Salesforce\Controller\Adminhtml\Queue
 */
class Product extends \Magenest\Salesforce\Controller\Adminhtml\Queue\AbstractionAction
{

    /** @var string */
    protected $type = Queue::TYPE_PRODUCT;
    /**
     * @return \Magento\Framework\App\ResponseInterface
     */
    public function execute()
    {
        if ($this->getRequest()->isAjax()) {
            $productCollection = $this->_productColFactory->create()->addFieldToSelect('entity_id');
            try {
                $ids = $this->getFilterDate($productCollection)->getAllIds();
                $queueIds = $this->getQueueIdsByType($this->type);
                $this->_queueResource->deleteMultiQueues($queueIds);
                $this->publishData($ids, $this->type);
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 0,
                    'message' => __('All Products are being added to queue.'),
                ]));
                return;
            } catch (\Exception $e) {
                $this->_logger->critical($e->getMessage());
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 0,
                    'message' => __('Something went wrong while adding record(s) to queue. Error: ' . $e->getMessage())
                ]));
                return;
            }
        }
        return $this->_redirect('*/*/index');
    }
}
