<?php
/**
 * Copyright © 2015 Magenest. All rights reserved.
 * See COPYING.txt for license details.
 *
 * Magenest_Salesforce extension
 * NOTICE OF LICENSE
 *
 * @category Magenest
 * @package  Magenest_Salesforce
 * @author   ThaoPV
 */
namespace Magenest\Salesforce\Model\ResourceModel;

use Magento\Framework\Model\ResourceModel\Db\AbstractDb;

/**
 * Class Report
 *
 * @package Magenest\Salesforce\Model\ResourceModel
 */
class Report extends AbstractDb
{

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init('magenest_salesforce_report', 'id');
    }

    /**
     * @param $magentoId
     * @param $table
     * @return string
     * @throws \Exception
     */
    public function getRecordByMagentoId($magentoId, $table)
    {
        try {
            $connection = $this->getConnection();
            $sql = $connection->select()->from(
                $this->getMainTable(),
                'record_id'
            )->where(
                'magento_id = ?',
                $magentoId
            )->where(
                'salesforce_table = ?',
                $table
            )->order([
                'id'
            ])->limit(1);
            return $connection->fetchOne($sql);
        } catch (\Exception $exception) {
            throw new \Exception($exception->getMessage());
        }
    }
}
