<?php

namespace Magenest\Salesforce\Model\Sync;

/**
 * Class DataGetter
 * @package Magenest\Salesforce\Model\Sync
 */
class DataGetter
{
    /**
     * @var Job
     */
    protected $_job;

    /**
     * DataGetter constructor.
     * @param Job $job
     */
    public function __construct(
        Job $job
    ) {
        $this->_job = $job;
    }

    /**
     * @param string $recordTypeId
     *
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllSalesforceAccounts($recordTypeId = '')
    {
        if ($recordTypeId != '') {
            $query  = "SELECT Id, Name FROM Account WHERE RecordTypeId = '" . $recordTypeId . "'";
        } else {
            $query  = "SELECT Id, Name FROM Account";
        }
        $result = $this->_job->sendBatchRequest('query', 'Account', $query);
        return $result;
    }

    /**
     * return an array of products on Salesforce
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllSalesforceProducts()
    {
        $query  = 'SELECT Id, ProductCode FROM Product2';
        $result = $this->_job->sendBatchRequest('query', 'Product2', $query);
        return $result;
    }

    /**
     * return an array of pricebook entries on Salesforce
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllPricebookEntry()
    {
        $query  = "SELECT Id, ProductCode FROM PricebookEntry ORDER BY Id";
        $result = $this->_job->sendBatchRequest('query', 'PricebookEntry', $query);
        return $result;
    }

    /**
     * return an array of Opportunities on Salesforce
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllSalesforceOpportunities()
    {
        $query  = "SELECT Id, NAME FROM Opportunity";
        $result = $this->_job->sendBatchRequest('query', 'Opportunity', $query);
        return $result;
    }

    /**
     * return an array of Campaigns on Salesforce
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllSalesforceCampaigns()
    {
        $query  = "SELECT Id,Name FROM Campaign";
        $result = $this->_job->sendBatchRequest('query', 'Campaign', $query);
        return $result;
    }
}
